/* GeoLocate.c generated by valac 0.42.7, the Vala compiler
 * generated from GeoLocate.vala, do not modify */

/*
* Copyright (c) 2017-2018 Carlos Suárez (https://gitlab.com/bitseater)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; If not, see <http://www.gnu.org/licenses/>.
*
* Authored by: Carlos Suárez <bitseater@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <geocode-glib/geocode-glib.h>
#include <libsoup/soup.h>
#include <json-glib/json-glib.h>
#include <stdio.h>
#include <glib/gi18n-lib.h>


#define METEO_UTILS_TYPE_COORD (meteo_utils_coord_get_type ())
typedef struct _MeteoUtilsCoord MeteoUtilsCoord;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))

struct _MeteoUtilsCoord {
	gdouble lat;
	gdouble lon;
};



GType meteo_utils_coord_get_type (void) G_GNUC_CONST;
MeteoUtilsCoord* meteo_utils_coord_dup (const MeteoUtilsCoord* self);
void meteo_utils_coord_free (MeteoUtilsCoord* self);
void meteo_utils_geolocate (void);
#define CONSTANTS_OWM_API_ADDR "http://api.openweathermap.org/data/2.5/"
void meteo_utils_get_location (MeteoUtilsCoord* result);
gint64 meteo_utils_update_id (const gchar* uri);
static void _vala_SoupBuffer_free (SoupBuffer* self);


MeteoUtilsCoord*
meteo_utils_coord_dup (const MeteoUtilsCoord* self)
{
	MeteoUtilsCoord* dup;
#line 21 "../src/Utils/GeoLocate.vala"
	dup = g_new0 (MeteoUtilsCoord, 1);
#line 21 "../src/Utils/GeoLocate.vala"
	memcpy (dup, self, sizeof (MeteoUtilsCoord));
#line 21 "../src/Utils/GeoLocate.vala"
	return dup;
#line 74 "GeoLocate.c"
}


void
meteo_utils_coord_free (MeteoUtilsCoord* self)
{
#line 21 "../src/Utils/GeoLocate.vala"
	g_free (self);
#line 83 "GeoLocate.c"
}


GType
meteo_utils_coord_get_type (void)
{
	static volatile gsize meteo_utils_coord_type_id__volatile = 0;
	if (g_once_init_enter (&meteo_utils_coord_type_id__volatile)) {
		GType meteo_utils_coord_type_id;
		meteo_utils_coord_type_id = g_boxed_type_register_static ("MeteoUtilsCoord", (GBoxedCopyFunc) meteo_utils_coord_dup, (GBoxedFreeFunc) meteo_utils_coord_free);
		g_once_init_leave (&meteo_utils_coord_type_id__volatile, meteo_utils_coord_type_id);
	}
	return meteo_utils_coord_type_id__volatile;
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 938 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 938 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 938 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 938 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 938 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 938 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 938 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 938 "glib-2.0.vapi"
	result = _tmp4_;
#line 938 "glib-2.0.vapi"
	return result;
#line 128 "GeoLocate.c"
}


void
meteo_utils_geolocate (void)
{
	GSettings* setting = NULL;
	GSettings* _tmp0_;
	gchar* uri1 = NULL;
	gchar* _tmp1_;
	gchar* uri2 = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	MeteoUtilsCoord mycoords = {0};
	MeteoUtilsCoord _tmp6_ = {0};
	GeocodeLocation* location = NULL;
	MeteoUtilsCoord _tmp7_;
	gdouble _tmp8_;
	MeteoUtilsCoord _tmp9_;
	gdouble _tmp10_;
	GeocodeLocation* _tmp11_;
	GeocodeReverse* reverse = NULL;
	GeocodeReverse* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 27 "../src/Utils/GeoLocate.vala"
	_tmp0_ = g_settings_new ("com.gitlab.bitseater.meteo");
#line 27 "../src/Utils/GeoLocate.vala"
	setting = _tmp0_;
#line 28 "../src/Utils/GeoLocate.vala"
	_tmp1_ = g_strdup (CONSTANTS_OWM_API_ADDR "weather?lat=");
#line 28 "../src/Utils/GeoLocate.vala"
	uri1 = _tmp1_;
#line 29 "../src/Utils/GeoLocate.vala"
	_tmp2_ = g_settings_get_string (setting, "apiid");
#line 29 "../src/Utils/GeoLocate.vala"
	_tmp3_ = _tmp2_;
#line 29 "../src/Utils/GeoLocate.vala"
	_tmp4_ = g_strconcat ("&APPID=", _tmp3_, NULL);
#line 29 "../src/Utils/GeoLocate.vala"
	_tmp5_ = _tmp4_;
#line 29 "../src/Utils/GeoLocate.vala"
	_g_free0 (_tmp3_);
#line 29 "../src/Utils/GeoLocate.vala"
	uri2 = _tmp5_;
#line 31 "../src/Utils/GeoLocate.vala"
	meteo_utils_get_location (&_tmp6_);
#line 31 "../src/Utils/GeoLocate.vala"
	mycoords = _tmp6_;
#line 32 "../src/Utils/GeoLocate.vala"
	_tmp7_ = mycoords;
#line 32 "../src/Utils/GeoLocate.vala"
	_tmp8_ = _tmp7_.lat;
#line 32 "../src/Utils/GeoLocate.vala"
	_tmp9_ = mycoords;
#line 32 "../src/Utils/GeoLocate.vala"
	_tmp10_ = _tmp9_.lon;
#line 32 "../src/Utils/GeoLocate.vala"
	_tmp11_ = geocode_location_new (_tmp8_, _tmp10_, (gdouble) GEOCODE_LOCATION_ACCURACY_UNKNOWN);
#line 32 "../src/Utils/GeoLocate.vala"
	location = _tmp11_;
#line 33 "../src/Utils/GeoLocate.vala"
	_tmp12_ = geocode_reverse_new_for_location (location);
#line 33 "../src/Utils/GeoLocate.vala"
	reverse = _tmp12_;
#line 195 "GeoLocate.c"
	{
		GeocodePlace* mycity = NULL;
		GeocodePlace* _tmp13_;
#line 36 "../src/Utils/GeoLocate.vala"
		_tmp13_ = geocode_reverse_resolve (reverse, &_inner_error0_);
#line 36 "../src/Utils/GeoLocate.vala"
		mycity = _tmp13_;
#line 36 "../src/Utils/GeoLocate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 205 "GeoLocate.c"
			goto __catch0_g_error;
		}
#line 37 "../src/Utils/GeoLocate.vala"
		if (mycity != NULL) {
#line 210 "GeoLocate.c"
			gchar* uri = NULL;
			MeteoUtilsCoord _tmp14_;
			gdouble _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			MeteoUtilsCoord _tmp22_;
			gdouble _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			const gchar* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			const gchar* _tmp38_;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp14_ = mycoords;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp15_ = _tmp14_.lat;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp16_ = double_to_string (_tmp15_);
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp17_ = _tmp16_;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp18_ = g_strconcat (uri1, _tmp17_, NULL);
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp19_ = _tmp18_;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp20_ = g_strconcat (_tmp19_, "&lon=", NULL);
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp21_ = _tmp20_;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp22_ = mycoords;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp23_ = _tmp22_.lon;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp24_ = double_to_string (_tmp23_);
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp25_ = _tmp24_;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp26_ = g_strconcat (_tmp21_, _tmp25_, NULL);
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp27_ = _tmp26_;
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp28_ = g_strconcat (_tmp27_, uri2, NULL);
#line 38 "../src/Utils/GeoLocate.vala"
			_tmp29_ = _tmp28_;
#line 38 "../src/Utils/GeoLocate.vala"
			_g_free0 (_tmp27_);
#line 38 "../src/Utils/GeoLocate.vala"
			_g_free0 (_tmp25_);
#line 38 "../src/Utils/GeoLocate.vala"
			_g_free0 (_tmp21_);
#line 38 "../src/Utils/GeoLocate.vala"
			_g_free0 (_tmp19_);
#line 38 "../src/Utils/GeoLocate.vala"
			_g_free0 (_tmp17_);
#line 38 "../src/Utils/GeoLocate.vala"
			uri = _tmp29_;
#line 39 "../src/Utils/GeoLocate.vala"
			_tmp30_ = uri;
#line 39 "../src/Utils/GeoLocate.vala"
			_tmp31_ = g_strdup_printf ("%" G_GINT64_FORMAT, meteo_utils_update_id (_tmp30_));
#line 39 "../src/Utils/GeoLocate.vala"
			_tmp32_ = _tmp31_;
#line 39 "../src/Utils/GeoLocate.vala"
			g_settings_set_string (setting, "idplace", _tmp32_);
#line 39 "../src/Utils/GeoLocate.vala"
			_g_free0 (_tmp32_);
#line 40 "../src/Utils/GeoLocate.vala"
			_tmp33_ = geocode_place_get_town (mycity);
#line 40 "../src/Utils/GeoLocate.vala"
			_tmp34_ = _tmp33_;
#line 40 "../src/Utils/GeoLocate.vala"
			g_settings_set_string (setting, "location", _tmp34_);
#line 41 "../src/Utils/GeoLocate.vala"
			_tmp35_ = geocode_place_get_state (mycity);
#line 41 "../src/Utils/GeoLocate.vala"
			_tmp36_ = _tmp35_;
#line 41 "../src/Utils/GeoLocate.vala"
			g_settings_set_string (setting, "state", _tmp36_);
#line 42 "../src/Utils/GeoLocate.vala"
			_tmp37_ = geocode_place_get_country_code (mycity);
#line 42 "../src/Utils/GeoLocate.vala"
			_tmp38_ = _tmp37_;
#line 42 "../src/Utils/GeoLocate.vala"
			g_settings_set_string (setting, "country", _tmp38_);
#line 37 "../src/Utils/GeoLocate.vala"
			_g_free0 (uri);
#line 311 "GeoLocate.c"
		}
#line 35 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (mycity);
#line 315 "GeoLocate.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp39_;
		const gchar* _tmp40_;
#line 35 "../src/Utils/GeoLocate.vala"
		e = _inner_error0_;
#line 35 "../src/Utils/GeoLocate.vala"
		_inner_error0_ = NULL;
#line 45 "../src/Utils/GeoLocate.vala"
		_tmp39_ = e;
#line 45 "../src/Utils/GeoLocate.vala"
		_tmp40_ = _tmp39_->message;
#line 45 "../src/Utils/GeoLocate.vala"
		g_debug ("GeoLocate.vala:45: %s", _tmp40_);
#line 35 "../src/Utils/GeoLocate.vala"
		_g_error_free0 (e);
#line 335 "GeoLocate.c"
	}
	__finally0:
#line 35 "../src/Utils/GeoLocate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 35 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (reverse);
#line 35 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (location);
#line 35 "../src/Utils/GeoLocate.vala"
		_g_free0 (uri2);
#line 35 "../src/Utils/GeoLocate.vala"
		_g_free0 (uri1);
#line 35 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (setting);
#line 35 "../src/Utils/GeoLocate.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 35 "../src/Utils/GeoLocate.vala"
		g_clear_error (&_inner_error0_);
#line 35 "../src/Utils/GeoLocate.vala"
		return;
#line 356 "GeoLocate.c"
	}
#line 26 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (reverse);
#line 26 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (location);
#line 26 "../src/Utils/GeoLocate.vala"
	_g_free0 (uri2);
#line 26 "../src/Utils/GeoLocate.vala"
	_g_free0 (uri1);
#line 26 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (setting);
#line 368 "GeoLocate.c"
}


static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
#line 58 "../src/Utils/GeoLocate.vala"
	g_boxed_free (soup_buffer_get_type (), self);
#line 377 "GeoLocate.c"
}


static gpointer
_json_object_ref0 (gpointer self)
{
#line 60 "../src/Utils/GeoLocate.vala"
	return self ? json_object_ref (self) : NULL;
#line 386 "GeoLocate.c"
}


void
meteo_utils_get_location (MeteoUtilsCoord* result)
{
	MeteoUtilsCoord coord = {0};
	gchar* uri = NULL;
	gchar* _tmp0_;
	SoupSession* session = NULL;
	SoupSession* _tmp1_;
	SoupMessage* message = NULL;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupSession* _tmp4_;
	SoupMessage* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 50 "../src/Utils/GeoLocate.vala"
	memset (&coord, 0, sizeof (MeteoUtilsCoord));
#line 51 "../src/Utils/GeoLocate.vala"
	_tmp0_ = g_strdup ("https://location.services.mozilla.com/v1/geolocate?key=test");
#line 51 "../src/Utils/GeoLocate.vala"
	uri = _tmp0_;
#line 52 "../src/Utils/GeoLocate.vala"
	_tmp1_ = soup_session_new ();
#line 52 "../src/Utils/GeoLocate.vala"
	session = _tmp1_;
#line 53 "../src/Utils/GeoLocate.vala"
	_tmp2_ = uri;
#line 53 "../src/Utils/GeoLocate.vala"
	_tmp3_ = soup_message_new ("GET", _tmp2_);
#line 53 "../src/Utils/GeoLocate.vala"
	message = _tmp3_;
#line 54 "../src/Utils/GeoLocate.vala"
	_tmp4_ = session;
#line 54 "../src/Utils/GeoLocate.vala"
	_tmp5_ = message;
#line 54 "../src/Utils/GeoLocate.vala"
	soup_session_send_message (_tmp4_, _tmp5_);
#line 426 "GeoLocate.c"
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp6_;
		JsonParser* _tmp7_;
		SoupMessage* _tmp8_;
		SoupMessageBody* _tmp9_;
		SoupBuffer* _tmp10_;
		SoupBuffer* _tmp11_;
		guint8* _tmp12_;
		gint _tmp12__length1;
		JsonObject* root = NULL;
		JsonParser* _tmp13_;
		JsonNode* _tmp14_;
		JsonObject* _tmp15_;
		JsonObject* _tmp16_;
		JsonObject* _tmp17_;
		GList* _tmp18_;
#line 57 "../src/Utils/GeoLocate.vala"
		_tmp6_ = json_parser_new ();
#line 57 "../src/Utils/GeoLocate.vala"
		parser = _tmp6_;
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp7_ = parser;
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp8_ = message;
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp9_ = _tmp8_->response_body;
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp10_ = soup_message_body_flatten (_tmp9_);
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp11_ = _tmp10_;
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp12_ = _tmp11_->data;
#line 58 "../src/Utils/GeoLocate.vala"
		_tmp12__length1 = (gint) _tmp11_->length;
#line 58 "../src/Utils/GeoLocate.vala"
		json_parser_load_from_data (_tmp7_, (const gchar*) _tmp12_, (gssize) -1, &_inner_error0_);
#line 58 "../src/Utils/GeoLocate.vala"
		__vala_SoupBuffer_free0 (_tmp11_);
#line 58 "../src/Utils/GeoLocate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 58 "../src/Utils/GeoLocate.vala"
			_g_object_unref0 (parser);
#line 470 "GeoLocate.c"
			goto __catch1_g_error;
		}
#line 60 "../src/Utils/GeoLocate.vala"
		_tmp13_ = parser;
#line 60 "../src/Utils/GeoLocate.vala"
		_tmp14_ = json_parser_get_root (_tmp13_);
#line 60 "../src/Utils/GeoLocate.vala"
		_tmp15_ = json_node_get_object (_tmp14_);
#line 60 "../src/Utils/GeoLocate.vala"
		_tmp16_ = _json_object_ref0 (_tmp15_);
#line 60 "../src/Utils/GeoLocate.vala"
		root = _tmp16_;
#line 62 "../src/Utils/GeoLocate.vala"
		_tmp17_ = root;
#line 62 "../src/Utils/GeoLocate.vala"
		_tmp18_ = json_object_get_members (_tmp17_);
#line 487 "GeoLocate.c"
		{
			GList* name_collection = NULL;
			GList* name_it = NULL;
#line 62 "../src/Utils/GeoLocate.vala"
			name_collection = _tmp18_;
#line 62 "../src/Utils/GeoLocate.vala"
			for (name_it = name_collection; name_it != NULL; name_it = name_it->next) {
#line 495 "GeoLocate.c"
				gchar* _tmp19_;
				gchar* name = NULL;
#line 62 "../src/Utils/GeoLocate.vala"
				_tmp19_ = g_strdup ((const gchar*) name_it->data);
#line 62 "../src/Utils/GeoLocate.vala"
				name = _tmp19_;
#line 502 "GeoLocate.c"
				{
					const gchar* _tmp20_;
#line 63 "../src/Utils/GeoLocate.vala"
					_tmp20_ = name;
#line 63 "../src/Utils/GeoLocate.vala"
					if (g_strcmp0 (_tmp20_, "location") == 0) {
#line 509 "GeoLocate.c"
						JsonObject* mycoords = NULL;
						JsonObject* _tmp21_;
						JsonObject* _tmp22_;
						JsonObject* _tmp23_;
						JsonObject* _tmp24_;
						JsonObject* _tmp25_;
#line 64 "../src/Utils/GeoLocate.vala"
						_tmp21_ = root;
#line 64 "../src/Utils/GeoLocate.vala"
						_tmp22_ = json_object_get_object_member (_tmp21_, "location");
#line 64 "../src/Utils/GeoLocate.vala"
						_tmp23_ = _json_object_ref0 (_tmp22_);
#line 64 "../src/Utils/GeoLocate.vala"
						mycoords = _tmp23_;
#line 65 "../src/Utils/GeoLocate.vala"
						_tmp24_ = mycoords;
#line 65 "../src/Utils/GeoLocate.vala"
						coord.lat = json_object_get_double_member (_tmp24_, "lat");
#line 66 "../src/Utils/GeoLocate.vala"
						_tmp25_ = mycoords;
#line 66 "../src/Utils/GeoLocate.vala"
						coord.lon = json_object_get_double_member (_tmp25_, "lng");
#line 67 "../src/Utils/GeoLocate.vala"
						_json_object_unref0 (mycoords);
#line 67 "../src/Utils/GeoLocate.vala"
						_g_free0 (name);
#line 67 "../src/Utils/GeoLocate.vala"
						break;
#line 538 "GeoLocate.c"
					} else {
						FILE* _tmp26_;
#line 69 "../src/Utils/GeoLocate.vala"
						_tmp26_ = stdout;
#line 69 "../src/Utils/GeoLocate.vala"
						fprintf (_tmp26_, "%s", _ ("Found an error"));
#line 545 "GeoLocate.c"
					}
#line 62 "../src/Utils/GeoLocate.vala"
					_g_free0 (name);
#line 549 "GeoLocate.c"
				}
			}
#line 62 "../src/Utils/GeoLocate.vala"
			(name_collection == NULL) ? NULL : (name_collection = (g_list_free (name_collection), NULL));
#line 554 "GeoLocate.c"
		}
#line 56 "../src/Utils/GeoLocate.vala"
		_json_object_unref0 (root);
#line 56 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (parser);
#line 560 "GeoLocate.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 56 "../src/Utils/GeoLocate.vala"
		e = _inner_error0_;
#line 56 "../src/Utils/GeoLocate.vala"
		_inner_error0_ = NULL;
#line 73 "../src/Utils/GeoLocate.vala"
		_tmp27_ = e;
#line 73 "../src/Utils/GeoLocate.vala"
		_tmp28_ = _tmp27_->message;
#line 73 "../src/Utils/GeoLocate.vala"
		g_debug ("GeoLocate.vala:73: %s", _tmp28_);
#line 56 "../src/Utils/GeoLocate.vala"
		_g_error_free0 (e);
#line 580 "GeoLocate.c"
	}
	__finally1:
#line 56 "../src/Utils/GeoLocate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 56 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (message);
#line 56 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (session);
#line 56 "../src/Utils/GeoLocate.vala"
		_g_free0 (uri);
#line 56 "../src/Utils/GeoLocate.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 56 "../src/Utils/GeoLocate.vala"
		g_clear_error (&_inner_error0_);
#line 56 "../src/Utils/GeoLocate.vala"
		return;
#line 597 "GeoLocate.c"
	}
#line 75 "../src/Utils/GeoLocate.vala"
	*result = coord;
#line 75 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (message);
#line 75 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (session);
#line 75 "../src/Utils/GeoLocate.vala"
	_g_free0 (uri);
#line 75 "../src/Utils/GeoLocate.vala"
	return;
#line 609 "GeoLocate.c"
}


gint64
meteo_utils_update_id (const gchar* uri)
{
	gint64 result = 0LL;
	SoupSession* session = NULL;
	SoupSession* _tmp0_;
	SoupMessage* message = NULL;
	SoupMessage* _tmp1_;
	gint64 id = 0LL;
	GError* _inner_error0_ = NULL;
#line 78 "../src/Utils/GeoLocate.vala"
	g_return_val_if_fail (uri != NULL, 0LL);
#line 79 "../src/Utils/GeoLocate.vala"
	_tmp0_ = soup_session_new ();
#line 79 "../src/Utils/GeoLocate.vala"
	session = _tmp0_;
#line 80 "../src/Utils/GeoLocate.vala"
	_tmp1_ = soup_message_new ("GET", uri);
#line 80 "../src/Utils/GeoLocate.vala"
	message = _tmp1_;
#line 81 "../src/Utils/GeoLocate.vala"
	soup_session_send_message (session, message);
#line 82 "../src/Utils/GeoLocate.vala"
	id = (gint64) 0;
#line 637 "GeoLocate.c"
	{
		JsonParser* parser = NULL;
		JsonParser* _tmp2_;
		SoupMessageBody* _tmp3_;
		SoupBuffer* _tmp4_;
		SoupBuffer* _tmp5_;
		guint8* _tmp6_;
		gint _tmp6__length1;
		JsonObject* root = NULL;
		JsonNode* _tmp7_;
		JsonObject* _tmp8_;
		JsonObject* _tmp9_;
		JsonObject* _tmp10_;
#line 84 "../src/Utils/GeoLocate.vala"
		_tmp2_ = json_parser_new ();
#line 84 "../src/Utils/GeoLocate.vala"
		parser = _tmp2_;
#line 85 "../src/Utils/GeoLocate.vala"
		_tmp3_ = message->response_body;
#line 85 "../src/Utils/GeoLocate.vala"
		_tmp4_ = soup_message_body_flatten (_tmp3_);
#line 85 "../src/Utils/GeoLocate.vala"
		_tmp5_ = _tmp4_;
#line 85 "../src/Utils/GeoLocate.vala"
		_tmp6_ = _tmp5_->data;
#line 85 "../src/Utils/GeoLocate.vala"
		_tmp6__length1 = (gint) _tmp5_->length;
#line 85 "../src/Utils/GeoLocate.vala"
		json_parser_load_from_data (parser, (const gchar*) _tmp6_, (gssize) -1, &_inner_error0_);
#line 85 "../src/Utils/GeoLocate.vala"
		__vala_SoupBuffer_free0 (_tmp5_);
#line 85 "../src/Utils/GeoLocate.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/Utils/GeoLocate.vala"
			_g_object_unref0 (parser);
#line 673 "GeoLocate.c"
			goto __catch2_g_error;
		}
#line 86 "../src/Utils/GeoLocate.vala"
		_tmp7_ = json_parser_get_root (parser);
#line 86 "../src/Utils/GeoLocate.vala"
		_tmp8_ = json_node_get_object (_tmp7_);
#line 86 "../src/Utils/GeoLocate.vala"
		_tmp9_ = _json_object_ref0 (_tmp8_);
#line 86 "../src/Utils/GeoLocate.vala"
		root = _tmp9_;
#line 87 "../src/Utils/GeoLocate.vala"
		_tmp10_ = root;
#line 87 "../src/Utils/GeoLocate.vala"
		id = json_object_get_int_member (_tmp10_, "id");
#line 83 "../src/Utils/GeoLocate.vala"
		_json_object_unref0 (root);
#line 83 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (parser);
#line 692 "GeoLocate.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 83 "../src/Utils/GeoLocate.vala"
		e = _inner_error0_;
#line 83 "../src/Utils/GeoLocate.vala"
		_inner_error0_ = NULL;
#line 89 "../src/Utils/GeoLocate.vala"
		_tmp11_ = e;
#line 89 "../src/Utils/GeoLocate.vala"
		_tmp12_ = _tmp11_->message;
#line 89 "../src/Utils/GeoLocate.vala"
		g_debug ("GeoLocate.vala:89: %s", _tmp12_);
#line 83 "../src/Utils/GeoLocate.vala"
		_g_error_free0 (e);
#line 712 "GeoLocate.c"
	}
	__finally2:
#line 83 "../src/Utils/GeoLocate.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 717 "GeoLocate.c"
		gint64 _tmp13_ = -1LL;
#line 83 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (message);
#line 83 "../src/Utils/GeoLocate.vala"
		_g_object_unref0 (session);
#line 83 "../src/Utils/GeoLocate.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 83 "../src/Utils/GeoLocate.vala"
		g_clear_error (&_inner_error0_);
#line 83 "../src/Utils/GeoLocate.vala"
		return _tmp13_;
#line 729 "GeoLocate.c"
	}
#line 91 "../src/Utils/GeoLocate.vala"
	result = id;
#line 91 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (message);
#line 91 "../src/Utils/GeoLocate.vala"
	_g_object_unref0 (session);
#line 91 "../src/Utils/GeoLocate.vala"
	return result;
#line 739 "GeoLocate.c"
}



